unit AfCmpWzrd;

interface

uses
  Windows, Forms, Menus, jpeg,ExtCtrls, SysUtils, ToolsAPI, dialogs,
  controls, graphics, shellapi, Classes,TypInfo,ToolIntf,Exptintf, Registry;

type
  TAFNewMenuItem = class
  private
    FTimer: TTimer;
    FInitialized: Boolean;
    FMainMenu: TMainMenu;
    FFileMenu: TMenuItem;
	 FNewMenuItem: TMenuItem;
	 fPkgList: TStrings;
	 PalettePageList: TStrings;
	 lastPalette,LastDir: String;
    procedure OnMenuItemClick(Sender: TObject);
  public
    procedure StartTimer;
    procedure AddMenuItem(Sender: TObject);
	 procedure RemoveMenuItem;
	 procedure SetPkgList;
	 procedure SetPalettePageList;
    Function AddUnit(Ancestor:String):STring;
  end;

var
  AFItem: TAFNewMenuItem;

procedure Register;

implementation
uses UFrmWzrd;
{$R AFBmp.res}
{ TAFNewMenuItem }

procedure TAFNewMenuItem.StartTimer;
begin
  FTimer := TTimer.Create(nil);
  FTimer.Interval := 1000;
  FTimer.OnTimer := AddMenuItem;
  FTimer.Enabled := True;
  FInitialized := False;
end;

procedure TAFNewMenuItem.AddMenuItem;
var
  i: Integer;
  MyBitmap: TBitmap;
begin
	MyBitmap := TBitmap.Create;
	MyBitmap.Handle := LoadBitmap(Hinstance,'AF');
   FreeAndNil(FTimer);
   // find Delphi's main menu
   FMainMenu := (BorlandIDEServices as INTAServices).MainMenu;
   // find File
   for i := 0 to FMainMenu.Items.Count - 1 do begin
		if AnsiSameCaption(FMainMenu.Items[i].Caption, 'Component') then begin
      	FFileMenu := FMainMenu.Items[i];
        	Break;
      end;
   end;

   FNewMenuItem := TMenuItem.Create(FFileMenu);
   FNewMenuItem.Caption := 'New AF-Component...';
   FNewMenuItem.OnClick := OnMenuItemClick;
   fnewmenuitem.Bitmap.Assign(MyBitmap);
   FFileMenu.Insert(0, FNewMenuItem);
   FInitialized := True;
end;

procedure TAFNewMenuItem.RemoveMenuItem;
var
  i: Integer;
begin
  if Assigned(FTimer) then
    FreeAndNil(FTimer);
  if not FInitialized then
    Exit;

  i := 0;
  while i < FFileMenu.Count do begin
	 if AnsiSameCaption(FFileMenu.Items[i].Caption, 'AF Component Wizard...') then
      FFileMenu.Remove(FFileMenu.Items[i])
    else
      Inc(i);
  end;
  FNewMenuItem.Free;
end;

procedure TAFNewMenuItem.OnMenuItemClick(Sender: TObject);
begin
Application.CreateForm(TFrmWZrd, FrmWzrd);
FrmWzrd.OpenForm(fpkglist,palettepagelist,LastPalette,LastDir);
FrmWzrd.Free;
end;
procedure TAFNewMenuItem.SetPkgList;
var
 I, J: Integer;
 CRef: TClass;
 StrName: String[255];
begin
	FPkgList := TStringList.Create;
   for i:=0 to ToolServices.GetModuleCount-1 do
   begin
   	for j:=0 to ToolServices.GetComponentCount(i)-1 do
      begin
      	CRef:= TClass(GetClass(ToolServices.GetComponentName(i,j)));
         while CRef <> nil do
         begin
         	StrName:= CRef.ClassName;
           	if fPkgList.IndexOf(StrName) = -1 then
            	fPkgList.Add(StrName);
           	if StrName <> 'TComponent' then
            	CRef:= CRef.ClassParent
         	else CRef:= nil;
         end;
   	end;
   end;
end;
procedure TAFNewMenuItem.SetPalettePageList;
var
   Reg: TRegistry;
	n,i: Integer;
   MyList: TStringList;
const
{$IFDEF VER140}
RegKey = ('Software\Borland\Delphi\6.0');
{$ELSE}
RegKey = ('Software\Borland\Delphi\7.0');
{$ENDIF}
begin
	MyLIst := TStringList.Create;
	PalettePageList := TStringList.Create;
	Reg:=TRegistry.Create;
	reg.RootKey := HKEY_CURRENT_USER;
	try
		  if Reg.OpenKeyReadOnly(regkey+'\Palette') then
		  Reg.GetValueNames(PalettePageList);
		  Reg.CloseKey;
		  Reg.OpenKey(regkey+'\New Component',false);
		  LastPalette := Reg.ReadString('PalettePage');
		  LastDir := Reg.ReadString('UnitDirName');
	finally
	 Reg.Free;
	end;

   MyList.Assign(PalettepageList);
	for n:=0 to PalettePageList.Count-1 do

	  if pos('.Hidden',PalettePageList[n]) > 0
	  then begin
		 	 MyList.Sort;
          MyList.Find(PalettePagelist[n],i);
          MyList.delete(i);
     end;
     PalettePageList.Assign(MyList);
     MyList.Free;
end;
Function TAFNewMenuItem.AddUnit(Ancestor:STring):STring;
var
	I: Integer;
   CRef: TClass;
   StrName, TmpUnit: STring;
   MyList: TStrings;
   Found: Boolean;
begin
	MyList := TStringList.Create;
   MyList.Add('Windows');
   MyList.Add('Messages');
   MyList.Add('SysUtils');
   MyLIst.Add('Classes');
	CRef:= TClass(GetClass(Ancestor));
   while CRef <> nil do
   	begin
      StrName:= CRef.ClassName;
      Found := False;
      TmpUnit := GetTypeData(PTypeInfo(cref.ClassInfo)).UnitName;
      For i := 0 to MyList.Count-1 do
      	begin
         	If MyList[i] = TmpUnit then
            	begin
               	Found := True;
                  break;
               end;
         end;
      If not Found then
      begin
      	if result <> '' then
         	result := result+', '+TmpUnit
         else
         	result := TmpUnit;
       	MyList.Add(TmpUnit);
      end;
      if StrName <> 'TComponent' then
      	CRef:= CRef.ClassParent
      else
         CRef:= nil;
    end;
If Result <> '' then
	result := ', '+result+';'
else
	Result := ';';
MyList.Free;
end;
procedure Register;
begin
  AFItem.StartTimer;
end;

initialization
  AFItem := TAFNewMenuItem.Create;
  AFItem.SetPkgList;
  AfItem.SetPalettePageList;
finalization
  AFItem.RemoveMenuItem;
  AfItem.fPkgList.Clear;
  AfItem.fPkgList.Free;
  AfItem.PalettePageList.Clear;
  AfItem.PalettePageList.Free;
  AFItem.Free;

end.
